package eu.oskar3123.spigot2fa.listener;

import eu.oskar3123.spigot2fa.Main;
import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.*;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.inventory.ItemStack;

public class MapListener implements Listener
{

    private Main plugin;

    public MapListener(Main plugin)
    {
        this.plugin = plugin;
    }

    @EventHandler
    public void quit(PlayerQuitEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getPlayer().getUniqueId()))
        {
            return;
        }
        plugin.tfaHandler.stopCreating(event.getPlayer());
        event.getPlayer().getInventory().setItemInMainHand(new ItemStack(Material.AIR));
    }

    @EventHandler
    public void drop(PlayerDropItemEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getPlayer().getUniqueId()))
        {
            return;
        }
        if (event.getItemDrop().getItemStack().getType() != Material.FILLED_MAP)
        {
            return;
        }
        plugin.tfaHandler.stopCreating(event.getPlayer());
        event.getPlayer().sendMessage("Aborted adding two-factor authentication.");
        event.getItemDrop().remove();
    }

    @EventHandler
    public void slot(PlayerItemHeldEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getPlayer().getUniqueId()))
        {
            return;
        }
        event.setCancelled(true);
    }

    @EventHandler
    public void open(InventoryOpenEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getPlayer().getUniqueId()))
        {
            return;
        }
        event.setCancelled(true);
    }

    @EventHandler
    public void open(InventoryClickEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getWhoClicked().getUniqueId()))
        {
            return;
        }
        event.setCancelled(true);
    }

    @EventHandler
    public void open(InventoryCreativeEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getWhoClicked().getUniqueId()))
        {
            return;
        }
        event.setCancelled(true);
    }

    @EventHandler
    public void open(InventoryDragEvent event)
    {
        if (!plugin.tfaHandler.isInProcess(event.getWhoClicked().getUniqueId()))
        {
            return;
        }
        event.setCancelled(true);
    }

}
